diff --git a/board/freescale/imx6sabresd/README b/board/freescale/imx6sabresd/README
index 628d35f..71f9fe2 100644
--- a/board/freescale/imx6sabresd/README
+++ b/board/freescale/imx6sabresd/README
@@ -3,11 +3,11 @@ How to use and build U-Boot on mx6sabresd:
 
 Currently there are four methods for booting mx6sabresd boards:
 
-1. Booting from SD card via normal U-Boot (u-boot.imx)
+1. Booting from SD card via normal U-Boot (u-boot-dtb.imx)
 
 2. Booting from eMMC via normal U-Boot
 
-3. Booting via SPL (SPL and u-boot.img)
+3. Booting via SPL (SPL and u-boot-dtb.img)
 
 4. Booting via Falcon mode (SPL launches the kernel directly)
 
@@ -15,42 +15,42 @@ Currently there are four methods for booting mx6sabresd boards:
 1. Booting from SD card via normal U-Boot
 -----------------------------------------
 
-$ make mx6qsabresd_defconfig (If you want to build for mx6qsabresd)
+$ make imx6q_sabresd_defconfig (If you want to build for imx6 quad sabresd)
 
 or
 
-$ make mx6dlsabresd_defconfig (If you want to build for mx6dlsabresd)
+$ make imx6dl_sabresd_defconfig (If you want to build for imx6 duallite sabresd)
 
 $ make
 
-This will generate the image called u-boot.imx.
+This will generate the image called u-boot-dtb.imx.
 
-- Flash the u-boot.imx binary into the SD card:
+- Flash the u-boot-dtb.imx binary into the SD card:
 
-$ sudo dd if=u-boot.imx of=/dev/sdb bs=1K seek=1 && sync
+$ sudo dd if=u-boot-dtb.imx of=/dev/sdb bs=1K seek=1 && sync
 
 
 2. Booting from eMMC via normal U-Boot
 --------------------------------------
 
-$ make mx6qsabresd_defconfig (If you want to build for mx6qsabresd)
+$ make imx6q_sabresd_defconfig (If you want to build for imx6 quad sabresd)
 
 or
 
-$ make mx6dlsabresd_defconfig (If you want to build for mx6dlsabresd)
+$ make imx6dl_sabresd_defconfig (If you want to build for imx6 duallite sabresd)
 
 $ make
 
-This will generate the image called u-boot.imx.
+This will generate the image called u-boot-dtb.imx.
 
-- Flash the u-boot.imx binary into the eMMC:
+- Flash the u-boot-dtb.imx binary into the eMMC:
 
 Set SW6 to download mode: 00001100
 
 Plug a usb cable to USB-OTG and load the u-boot image using the imx_usb_loader
 tool (https://github.com/boundarydevices/imx_usb_loader):
 
-$ sudo ./imx_usb u-boot.imx
+$ sudo ./imx_usb u-boot-dtb.imx
 
 In U-boot change the eMMC partition config:
 
@@ -60,9 +60,9 @@ Mount the eMMC in the host PC:
 
 => ums 0 mmc 2
 
-Flash the u-boot.imx binary
+Flash the u-boot-dtb.imx binary
 
-$ sudo dd if=u-boot.imx of=/dev/sdX bs=1K seek=1 && sync
+$ sudo dd if=u-boot-dtb.imx of=/dev/sdX bs=1K seek=1 && sync
 
 Set SW6 to eMMC 8-bit boot: 11010110
 
@@ -70,38 +70,38 @@ Set SW6 to eMMC 8-bit boot: 11010110
 3. Booting via SPL
 ------------------
 
-Other method for building U-Boot on mx6qsabresd and mx6qpsabresd is
+Other method for building U-Boot on imx6 quad and quadplus sabresd is
 through SPL. In order to do so:
 
-$ make mx6sabresd_spl_defconfig
+$ make imx6qdl_sabresd_spl_defconfig
 $ make
 
-This will generate the SPL image called SPL and the u-boot.img.
+This will generate the SPL image called SPL and the u-boot-dtb.img.
 
 - Flash the SPL image into the SD card:
 
 $ sudo dd if=SPL of=/dev/sdb bs=1K seek=1 && sync
 
-- Flash the u-boot.img image into the SD card:
+- Flash the u-boot-dtb.img image into the SD card:
 
-$ sudo dd if=u-boot.img of=/dev/sdb bs=1K seek=69 && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdb bs=1K seek=69 && sync
 
 
 4. Booting via Falcon mode
 --------------------------
 
-$ make mx6sabresd_spl_defconfig
+$ make imx6qdl_sabresd_spl_defconfig
 $ make
 
-This will generate the SPL image called SPL and the u-boot.img.
+This will generate the SPL image called SPL and the u-boot-dtb.img.
 
 - Flash the SPL image into the SD card:
 
 $ sudo dd if=SPL of=/dev/sdb bs=1K seek=1 oflag=sync status=none && sync
 
-- Flash the u-boot.img image into the SD card:
+- Flash the u-boot-dtb.img image into the SD card:
 
-$ sudo dd if=u-boot.img of=/dev/sdb bs=1K seek=69 oflag=sync status=none && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdb bs=1K seek=69 oflag=sync status=none && sync
 
 Create a partition for root file system and extract it there:
 